<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Community Edition 1.0.0 (Release Candidate 2)           |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify it  |
// | under the terms of the GNU General Public License version 3 as published |
// | by the Free Software Foundation.                                         |
// |                                                                          |
// | This program is distributed in the hope that it will be useful, but      |
// | WITHOUT ANY WARRANTY; without even the implied warranty of               |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For more details    |
// | see the GNU General Public License.                                      |
// |                                                                          |
// | You should have received a copy of the GNU General Public License along  |
// | with this program; if not, see http://www.gnu.org/licenses or write to   |
// | the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,     |
// | Boston, MA 02110-1301 USA.                                               |
// |                                                                          |
// | You can contact Esselbach Internet Solutions at the following address:   |
// | Rautenstrauchgasse 6-16/4, A-1110 Vienna, Austria                        |
// | or via email at office (at) esselbach.com                                |
// |                                                                          |
// | The interactive user interfaces in modified source and object code       |
// | versions of this program must display Appropriate Legal Notices,         |
// | as required under Section 5 of the GNU General Public License version 3. |
// | In accordance with Section 7(b) of the GNU General Public License        |
// | version 3, these Appropriate Legal Notices must retain the display of    |
// | the "Managed with Contentteller" logo and retain the original            |
// | copyright notice.                                                        |
// |                                                                          |
// | If the display of the logos are not reasonably feasible for technical    |
// | reasons, the Appropriate Legal Notices must display the words "Managed   |
// | with Contentteller"                                                      |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+ 
// | Build: 499                                                               |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Blocks
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */
if( !defined( "CONTENTTELLER" ) )
{
	die( "Error" );
}
/**
 * News poll block
 * @author Philipp Louis Esselbach
 */
if( $preferences[ 'news_active' ] )
{
	$news_poll = ( isset( $datastore[ 'news_poll' ] ) ) ? $datastore[ 'news_poll' ] : "" ;
	
	if( !$news_poll or $user[ 'user_status' ])
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		$results = $database -> dbquery( "SELECT newsstory_id, newsstory_seo, newsstory_poll, newsstory_pollresults FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE NOT(newsstory_poll = '') AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "') ORDER BY newsstory_date DESC LIMIT 1" ); // Error mod - Added newsstory_id
		$news_poll = "";
		
		if( $database -> dbrows( $results ) )
		{
			list( $newsstory_id, $newsstory_seo, $newsstory_poll, $newsstory_pollresults ) = $database -> dbrow( $results ); // Error mod - Added $newsstory_id
			$input_poll_array = explode( "|", $newsstory_poll );
			$input_results_array = ( $newsstory_pollresults ) ? explode( "|", $newsstory_pollresults ) : array() ;
			$news_poll .= "<div style=\"text-align: center;\"><strong>Poll: " . htmlspecialchars( base64_decode( $input_poll_array[ 0 ] ) ) . "</strong></div><br />";
			
			$totalvotes = 0;
// Error mod - Start
			if( $preferences[ 'news_allow_unregpolls' ] or $user[ 'user_status' ] )
			{
				if( $user[ 'user_status' ] )
				{
					$query = $database -> dbquery( "SELECT newspoll_id FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $newsstory_id . "' and newspoll_user = '" . intval( $user[ 'user_id' ] ) . "'" );
					$voted = $database -> dbrows( $query );
				}
				else
				{
					$uniqueid = md5( $_SERVER[ 'HTTP_USER_AGENT' ] . $system -> getip() );
					$query = $database -> dbquery( "SELECT newspoll_id FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $newsstory_id . "' and newspoll_uniqueid = '" . $uniqueid . "'" );
					$voted = $database -> dbrows( $query );
				}
			}

			if( ( !$voted and $preferences[ 'news_allow_unregpolls' ] ) or( !$voted and $user[ 'user_status' ] ) )
			{
				$input_poll_choice = $input_poll_array[ 1 ];
				$news_poll .= "<form action=\"contentteller.php\" method=\"post\" id=\"pollform\">";
				for( $i = 1; $i < 22; $i++ )
				{
					$insert[ 'poll_option_id' ] = $i - 1;
					$insert[ 'poll_option' ] = $system -> decode( $input_poll_array[ $i ] );
					
					if( $insert[ 'poll_option' ] )
					{
						if( $input_poll_choice )
						{
							$news_poll .= "<input type=\"checkbox\" name=\"input_votes[]\" value=\"".$insert['poll_option_id']."\" />".$insert['poll_option']."<br />";
						}
						else
						{
							$news_poll .= "<input type=\"radio\" name=\"input_vote\" value=\"".$insert['poll_option_id']."\" />".$insert['poll_option']."<br />";
						}
					}
				}
				session_start();
				$insert[ 'news_security_hash' ] = md5( rand( 1, 32768 ) );
				$_SESSION[ 'news_security_hash' ] = $insert[ 'news_security_hash' ];				
				$news_poll .= "<input type=\"hidden\" name=\"input_security_hash\" value=\"".$insert['news_security_hash']."\" /><input type=\"hidden\" name=\"faction\" value=\"news_dopoll\" /><input type=\"hidden\" name=\"input_newsstory_id\" value=".$newsstory_id."\" /><input type=\"submit\" value=\"Vote\" /></form>";
			}
			else 
			{
				for( $i = 0; $i < count( $input_results_array ); $i++ )
				{
					$totalvotes = $totalvotes + $input_results_array[ $i ];
				}
				
				for( $i = 2; $i < 22; $i++ )
				{
					$y = $i - 2;
					
					if( $input_poll_array[ $i ] )
					{
						if( isset( $input_results_array[ $y ] ) and $input_results_array[ $y ] )
						{
							$poll_votes = $input_results_array[ $y ];
							$poll_percent = ceil( 100 * $poll_votes / $totalvotes );
						}
						else
						{
							$poll_votes = 0;
							$poll_percent = 0;
						}
						
						$news_poll .= htmlspecialchars( base64_decode( $input_poll_array[ $i ] ) ) . "<br />";
						$news_poll .= "<img src=\"images/votebar.png\" width=\"" . $poll_percent . "\" height=\"9\" alt=\"\" /><br />";
						$news_poll .= $poll_percent . "% (" . $poll_votes . " votes) <br /><br />";
					}
				}
			}
			
// Error mod - End

		}
		else
		{
			if( $config[ 'ADMIN_LANGUAGE' ] == "de" )
			{
				$news_poll .= "Es gibt derzeit keine Umfrage in der Nachrichten Datenbank";
			}
			else
			{
				$news_poll .= "There are currently no polls in the news database";
			}
		}

		// Error mod
		if (!$user[ 'user_status' ])
		{
			$system -> datastoreput( "news_poll", $news_poll );
		}
	}
	
	echo $news_poll;
}
else
{
	if( $config[ 'ADMIN_LANGUAGE' ] == "de" )
	{
		echo "Das Nachrichtenmodul ist derzeit deaktiviert";
	}
	else 
	{
		echo "The news module is inactive";
	}
}
?>